SystemOrganization addCategory: #CopyHierarchy!

Object subclass: #CopyHierarchy
	instanceVariableNames: 'classNamePrefix classCategoryForDupedClass renameMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!CopyHierarchy classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/20/2012 12:20'!
classCategoryForExamples

	^'CopyHierarchyExampleResult'! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:23'!
copySubclassesOfCollection

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X10';
		runWithSubclasses: Collection.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:24'!
copySubclassesOfGradientFillStyle

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X20';
		runWithSubclasses: GradientFillStyle.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:24'!
copySubclassesOfLineSegment

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X30';
		runWithSubclasses: LineSegment.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfArray

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X40';
		runWithSuperclasses: Array.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfCollection

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X50';
		runWithSuperclasses: Collection.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfNil

	"This is invalid request. Should not do anything."
	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X60';
		runWithSuperclasses: nil.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:19'!
copySuperclassesOfObject

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X70';
		runWithSuperclasses: Object.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:19'!
copySuperclassesOfProtoObject

	"This is invalid request. Should not do anything."
	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'x80';
		runWithSuperclasses: ProtoObject.! !

!CopyHierarchy classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/20/2012 12:08'!
runAllExample

	(self class methodsInCategory: 'example') do: [:sel|
		self perform: sel ].! !

!CopyHierarchy methodsFor: 'private' stamp: 'HwaJong 12/4/2012 11:47'!
changeSuperclassAfterDupClass: aClass

	|dup|
	dup := self dupClass: aClass.
	dup superclass name = (self nameOfDupOfClass: aClass superclass) ifTrue: [^self].
	(Smalltalk classNamed: dup name) moveToSuperclassNamed: (self nameOfDupOfClass: aClass superclass).! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:09'!
classCategoryForDupedClass: aString 

	classCategoryForDupedClass := aString! !

!CopyHierarchy methodsFor: 'testing' stamp: 'hjo 7/20/2012 11:09'!
classExistsByName: aSymbol

	^[Smalltalk at: aSymbol. true] on: KeyNotFound do: [:exp| false ].! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:09'!
classNamePrefix: aString 

	classNamePrefix := aString ! !

!CopyHierarchy methodsFor: 'private' stamp: 'HwaJong 12/11/2012 17:05'!
dupClass: aClass

	| dupName dup |
	dupName := self nameOfDupOfClass: aClass.
	(self classExistsByName: dupName) ifTrue: [ ^Smalltalk at: dupName ].
	dup := aClass duplicateClassWithNewName: dupName.
	renameMap at: aClass name put: dupName.
	dup category: classCategoryForDupedClass.
	^dup! !

!CopyHierarchy methodsFor: 'initialize-release' stamp: 'HwaJong 12/11/2012 17:02'!
initialize
super initialize.
renameMap := Dictionary new.! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:10'!
nameOfDupOfClass: aClass

	^(classNamePrefix, aClass name) asSymbol! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 12:33'!
newClasses
	^ renameMap values collect: [ :ea | Smalltalk classNamed: ea ]! !

!CopyHierarchy methodsFor: 'undo' stamp: 'hjo 7/20/2012 11:11'!
removeCategoryOfDupes

	self class environment organization removeSystemCategory: classCategoryForDupedClass.! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 13:05'!
renameClassReferencesToCopied
	RenameClassReferencesToCopied new
		masterObject: self;
		renameMap: renameMap;
		doThings.! !

!CopyHierarchy methodsFor: 'public operation' stamp: 'hjo 7/20/2012 11:16'!
runWithSubclasses: aClass

	self dupClass: aClass.
	aClass allSubclassesDo: [:each| self changeSuperclassAfterDupClass: each ].! !

!CopyHierarchy methodsFor: 'public operation' stamp: 'hjo 7/20/2012 11:27'!
runWithSuperclasses: aClass

	aClass = nil ifTrue: [^self].
	aClass superclass = nil ifTrue: [ ^self "^self dupClass: aClass" ].
	self runWithSuperclasses: (aClass superclass).
	self changeSuperclassAfterDupClass: aClass.! !

Object subclass: #RenameClassReferencesToCopied
	instanceVariableNames: 'oneClassName renameMap masterObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!RenameClassReferencesToCopied methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 14:48'!
doThings
	renameMap keys
		do: [ :each | 
			oneClassName := each.
			masterObject newClasses
				do: [ :each2 | (self methodsOfReferingOldClassesInNewClass: each2) do: [ :each3 | self rewriteMethodsReferingToOldClass: each3 ] ] ]! !

!RenameClassReferencesToCopied methodsFor: 'accessing' stamp: 'HwaJong 12/12/2012 13:03'!
masterObject: aCopyHierarchy 
	masterObject := aCopyHierarchy! !

!RenameClassReferencesToCopied methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 15:00'!
methodsOfReferingOldClassesInNewClass: aClass
	^aClass methods select: [ :m | m hasLiteralSuchThat: [ :ass | ass value = self oneClass ] ].! !

!RenameClassReferencesToCopied methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 14:35'!
newOneClassName
	^ renameMap at: oneClassName! !

!RenameClassReferencesToCopied methodsFor: 'accessing' stamp: 'HwaJong 12/12/2012 14:40'!
oneClass
	^Smalltalk classNamed: oneClassName! !

!RenameClassReferencesToCopied methodsFor: 'accessing' stamp: 'HwaJong 12/12/2012 12:58'!
renameMap: aDictionary 
	renameMap := aDictionary ! !

!RenameClassReferencesToCopied methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 14:44'!
replacer
	 ^ (RBParseTreeRewriter replaceLiteral: oneClassName with: self newOneClassName)
		replace: oneClassName with: self newOneClassName;
		replaceArgument: self newOneClassName
			withValueFrom: [ :aNode | self refactoringError: self newOneClassName , ' already exists within the reference scope' ];
		yourself! !

!RenameClassReferencesToCopied methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/12/2012 14:46'!
rewriteMethodsReferingToOldClass: aClass
	| rewriteSucceeded parseTree |
	parseTree := aClass parseTree.
	rewriteSucceeded := self replacer executeTree: parseTree.
	rewriteSucceeded
		ifTrue: [ aClass methodClass compile: parseTree newSource classified: aClass category notifying: nil ]! !
